Main Page glibmm Namespaces Book

# Gio::Resolver Class Reference

Asynchronous and cancellable DNS resolver. More...

Inheritance diagram for Gio::Resolver:

[legend]

List of all members.

## Public Member Functions
virtual | ~Resolver ()
GResolver* | gobj ()
| Provides access to the underlying C GObject.
const GResolver* | gobj () const
| Provides access to the underlying C GObject.
GResolver* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ListHandle< Glib::RefPtr <InetAddress >> | lookup_by_name (const Glib::ustring& hostname, const Glib::RefPtr<Cancellable>& cancellable)
| Synchronously resolves hostname to determine its associated IP address(es).
Glib::ustring | lookup_by_address (const Glib::RefPtr<InetAddress>& address, const Glib::RefPtr<Cancellable>& cancellable)
| Synchronously reverse-resolves address to determine its associated hostname.
ListHandle_SrvTarget | lookup_service (const Glib::ustring& service, const Glib::ustring& protocol, const Glib::ustring& domain, const Glib::RefPtr<Cancellable>& cancellable)
| Synchronously performs a DNS SRV lookup for the given service and protocol in the given domain and returns an array of SrvTarget.
## Static Public Member Functions
static Glib::RefPtr<Resolver> | get_default ()
static void | set_default (const Glib::RefPtr<Resolver>& resolver)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr<Gio::Resolver> | wrap (GResolver* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Asynchronous and cancellable DNS resolver.

Resolver provides cancellable synchronous and asynchronous DNS resolution, for hostnames (lookup_by_address(), lookup_by_name() and their async variants) and SRV (service) records (lookup_service()).

NetworkAddress and NetworkService provide wrappers around Resolver functionality that also implement SocketConnectable, making it easy to connect to a remote host/service.

## Constructor& Destructor Documentation

virtual Gio::Resolver::~Resolver | ( |  | ) | `[virtual]`

## Member Function Documentation

GResolver* Gio::Resolver::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GResolver* Gio::Resolver::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GResolver* Gio::Resolver::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

static Glib::RefPtr<Resolver> Gio::Resolver::get_default | ( |  | ) | `[static]`

static void Gio::Resolver::set_default | ( | const Glib::RefPtr<Resolver>& | resolver | ) | `[static]`

Glib::ListHandle<Glib::RefPtr<InetAddress>> Gio::Resolver::lookup_by_name | ( | const Glib::ustring& | hostname,
|  | const Glib::RefPtr<Cancellable>& | cancellable |
| ) |  |  |

Synchronously resolves hostname to determine its associated IP address(es).

hostname may be an ASCII-only or UTF-8 hostname, or the textual form of an IP address (in which case this just becomes a wrapper around g_inet_address_new_from_string()).

On success, g_resolver_lookup_by_name() will return a List of InetAddress, sorted in order of preference. (That is, you should attempt to connect to the first address first, then the second if the first fails, etc.)

If the DNS resolution fails, error (if non-`0`) will be set to a value from ResolverError.

If cancellable is non-`0`, it can be used to cancel the operation, in which case error (if non-`0`) will be set to IO_ERROR_CANCELLED.

If you are planning to connect to a socket on the resolved IP address, it may be easier to create a NetworkAddress and use its SocketConnectable interface.

Parameters:

  | hostname | The hostname to look up.
  | cancellable | A Cancellable, or `0`.

Returns:
  A List of InetAddress, or `0` on error. You must unref each of the addresses and free the list when you are done with it. (You can use g_resolver_free_addresses() to do this.)

.

Glib::ustring Gio::Resolver::lookup_by_address | ( | const Glib::RefPtr<InetAddress>& | address,
|  | const Glib::RefPtr<Cancellable>& | cancellable |
| ) |  |  |

Synchronously reverse-resolves address to determine its associated hostname.

If the DNS resolution fails, error (if non-`0`) will be set to a value from ResolverError.

If cancellable is non-`0`, it can be used to cancel the operation, in which case error (if non-`0`) will be set to IO_ERROR_CANCELLED.

Parameters:

  | address | The address to reverse-resolve.
  | cancellable | A Cancellable, or `0`.

Returns:
  A hostname (either ASCII-only, or in ASCII-encoded form), or `0` on error.

.

ListHandle_SrvTarget Gio::Resolver::lookup_service | ( | const Glib::ustring& | service,
|  | const Glib::ustring& | protocol,
|  | const Glib::ustring& | domain,
|  | const Glib::RefPtr<Cancellable>& | cancellable |
| ) |  |  |

Synchronously performs a DNS SRV lookup for the given service and protocol in the given domain and returns an array of SrvTarget.

domain may be an ASCII-only or UTF-8 hostname. Note also that the service and protocol arguments <emphasis>do not</emphasis> include the leading underscore that appears in the actual DNS entry.

On success, g_resolver_lookup_service() will return a List of SrvTarget, sorted in order of preference. (That is, you should attempt to connect to the first target first, then the second if the first fails, etc.)

If the DNS resolution fails, error (if non-`0`) will be set to a value from ResolverError.

If cancellable is non-`0`, it can be used to cancel the operation, in which case error (if non-`0`) will be set to IO_ERROR_CANCELLED.

If you are planning to connect to the service, it is usually easier to create a NetworkService and use its SocketConnectable interface.

Parameters:

  | service | The service type to look up (eg, "ldap").
  | protocol | The networking protocol to use for service (eg, "tcp").
  | domain | The DNS domain to look up the service in.
  | cancellable | A Cancellable, or `0`.

Returns:
  A List of SrvTarget, or `0` on error. You must free each of the targets and the list when you are done with it. (You can use g_resolver_free_targets() to do this.)

.

## Friends And Related Function Documentation

Glib::RefPtr<Gio::Resolver> wrap | ( | GResolver * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- resolver.h